<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';
import { UseLocalizedVideoSubtitles } from '~/mixins';
import { CtfImage } from '~/models';

interface Content {
  header: string;
  description: string;
  button?: {
    text: string;
    href: string;
    gaName: string;
  };
  url?: string;
  image?: CtfImage;
}

export default Vue.extend({
  mixins: [UseLocalizedVideoSubtitles],
  props: {
    videos: {
      // this component was build for videos, but has been retrofitten to use images too
      type: Array as PropType<Array<Content>>,
      required: true,
    },
  },
});
</script>

<template>
  <div class="videos">
    <div
      v-for="video in videos"
      :key="video.header"
      class="video"
      :class="{ spacing: video.image }"
    >
      <div class="text">
        <SlpTypography variant="heading3-bold" tag="h3">{{
          video.header
        }}</SlpTypography>
        <div
          class="video__description"
          v-html="$md.render(video.description)"
        ></div>
        <SlpButton
          v-if="video.button"
          :href="video.button.href"
          class="cta"
          :data-ga-name="video.button.gaName"
          data-ga-location="body"
        >
          {{ video.button.text }}
          <SlpIcon name="chevron-right" variant="product" class="slp-ml-8" />
        </SlpButton>
      </div>
      <div v-if="video.url" class="video-player">
        <iframe
          :src="createVideoSource(video.url)"
          title="video player"
          frameborder="0"
          allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture"
          allowfullscreen
        ></iframe>
      </div>
      <div v-if="video.image" class="image">
        <img :src="video.image.file.url" />
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.videos {
  display: flex;
  flex-direction: column;
  gap: 80px;
  margin: 192px 0;
  .video {
    display: flex;
    flex-direction: column;
    gap: 16px;
    @media (min-width: $breakpoint-lg) {
      flex-direction: row;
    }

    &__description {
      font-size: 18px;
      font-weight: 400;
      line-height: 28px;
    }

    .text {
      display: flex;
      flex-direction: column;
      gap: 12px;
      .cta {
        width: fit-content;
      }
    }

    .video-player {
      flex-basis: 60%;
      display: flex;
      align-items: center;
      justify-content: center;
      iframe {
        @media (min-width: $breakpoint-lg) {
          min-width: 735px;
          min-height: 432px;
        }
      }
    }
  }
}

.spacing {
  margin-top: $spacing-160;
  margin-bottom: $spacing-160;

  @media (max-width: $breakpoint-lg) {
    margin-top: $spacing-48;
    margin-bottom: $spacing-48;
  }
}

.image {
  flex-basis: 60%;
  margin: $spacing-48;
  img {
    max-width: 300px;
    display: block;
    margin: 0 auto;
  }
}
</style>
